using System;
using System.Text;
using org.unicode;
using System.Text.RegularExpressions;
using System.Runtime.InteropServices;

public class Program
{
    #region Foldstring
#if !MONO
    [Flags]
    private enum MapFlags
    {
        MAP_FOLDCZONE = 0x00000010,// fold compatibility zone chars
        MAP_PRECOMPOSED = 0x00000020,// convert to precomposed chars
        MAP_COMPOSITE = 0x00000040, // convert to composite chars
        MAP_FOLDDIGITS = 0x00000080 // all digits to ASCII 0-9
    }
    [DllImport("kernel32.dll")]
    static extern int FoldString(int dwMapFlags, string lpSrcStr, int cchSrc,
       [Out] StringBuilder lpDestStr, int cchDest);

    public static string RemoveDiacritics1(string stIn)
    {
        StringBuilder sb = new StringBuilder();
        FoldString((int)MapFlags.MAP_COMPOSITE, stIn, stIn.Length, sb, stIn.Length * 2);
        return Regex.Replace(sb.ToString(), @"\p{Sk}", "");
    } 
#endif
    #endregion

    #region PartVietPad
    public static string RemoveDiacritics2(string strIn)
    {
        Normalizer n = new Normalizer(Normalizer.D);
        return Regex.Replace(n.normalize(strIn), "\\p{Mn}+", "");
    } 
    #endregion

    public static void Main(string[] args)
    {
        string str = "Canción";
#if !MONO
        // Usando API de FoldString
        Console.WriteLine(RemoveDiacritics1(str));
#endif
        // Usando parte del código de VietPad (http://vietpad.sourceforge.net)
        Console.WriteLine(RemoveDiacritics2(str));
	Console.Read();
    }
}
