using System;
using System.Collections;
	
namespace org.unicode
{	
	/// <summary> Integer hash table. Uses Java Hashtable for now.
	/// </summary>
	/// <author> Mark Davis
	/// 
	/// </author>
	
	public class IntHashtable
	{
		private void  InitBlock()
		{
			table = new Hashtable();
		}
		internal const System.String copyright = "Copyright � 1998-1999 Unicode, Inc.";
		
		public IntHashtable(int defaultValue)
		{
			InitBlock();
			this.defaultValue = defaultValue;
		}
		
		public virtual void  Put(int key, int ivalue)
		{
			if (ivalue == defaultValue)
			{
				table.Remove(key);
			}
			else
			{
				table[key] = ivalue;
			}
		}
		
		public virtual int Get(int key)
		{
			object ivalue = table[key];
			if (ivalue == null)
				return defaultValue;
			return ((Int32) ivalue);
		}

		private int defaultValue;
		//UPGRADE_NOTE: The initialization of  'table' was moved to method 'InitBlock'. 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="jlca1005"'
		private Hashtable table;
	}
}