using System;
using System.Collections;

namespace org.unicode
{	
	/// <summary> Integer-String hash table. Uses Java Hashtable for now.
	/// </summary>
	/// <author> Mark Davis
	/// 
	/// </author>
	
	public class IntStringHashtable
	{
		private void  InitBlock()
		{
			table = new Hashtable();
		}
		internal const string copyright = "Copyright � 1998-1999 Unicode, Inc.";
		
		public IntStringHashtable(string defaultValue)
		{
			InitBlock();
			this.defaultValue = defaultValue;
		}
		
		public virtual void Put(int key, string svalue)
		{
			if (svalue == defaultValue)
			{
				table.Remove(key);
			}
			else
			{
				table[key] = svalue;
			}
		}
		
		public virtual string Get(int key)
		{
			object svalue = table[key];
			if (svalue == null)
				return defaultValue;
			return (string) svalue;
		}
			
		private string defaultValue;
		//UPGRADE_NOTE: The initialization of  'table' was moved to method 'InitBlock'. 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="jlca1005"'
		private Hashtable table;
	}
}